package rocks.zipcode.io.quiz4.fundamentals;

import java.util.HashSet;
import java.util.Set;

/**
 * @author leon on 18/12/2018.
 */
public class PalindromeEvaluator {
    public static String[] getAllPalindromes(String string) {

        Set<CharSequence> stringSet = new HashSet<>();

        for(int i =1; i <= string.length();i++){
            for(int j =i; j<string.length(); j++){
                if(isPalindrome(string.substring(i, j+1))){
                    stringSet.add(string.substring(i,j+1));
                }
            }
        }

        stringSet.add(string);

        return stringSet.toArray(new String[0]);
    }

    public static Boolean isPalindrome(String string) {

        StringBuilder builder = new StringBuilder();
        builder.append(string);

        String reversedString = builder.reverse().toString();

        for(int i = 0; i < string.length()/2; i++){
            if(string.charAt(i) != string.charAt(string.length()-1-i)){
                return false;
            }else if(!reverseString(string).equals(reversedString)){
                return false;
            }
        }

        return true;
    }

    public static String reverseString(String string) {

        StringBuilder builder = new StringBuilder();

        builder.append(string);

        builder = builder.reverse();

        return builder.toString();
    }
}
