package rocks.zipcode.io.quiz4.objectorientation;

import com.sun.deploy.util.StringUtils;
import com.sun.tools.doclets.internal.toolkit.builders.AbstractBuilder;

import java.util.ArrayList;
import java.util.List;
import java.util.StringJoiner;

/**
 * @author leon on 11/12/2018.
 */
public class StringAssembler {


    StringBuilder builder = new StringBuilder();

    Character delimeter;

    public StringAssembler(Character delimeter) {
        this.delimeter = delimeter;
    }

    public StringAssembler append(String str) {

        builder.append(str);
        builder.append(delimeter.toString());

        return this;
    }

    public String assemble() {

        builder.deleteCharAt(builder.toString().length()-1);


        return builder.toString();
    }
}
