package rocks.zipcode.io.quiz4.fundamentals;

import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;

/**
 * @author leon on 11/12/2018.
 */
public class StringEvaluator {
    public static String[] getAllPrefixes(String string) {

        HashSet<String> stringSet = new HashSet<>();

        if(string.length() == 1){
            Character letter = string.charAt(0);
            stringSet.add(letter.toString());
        }
        else {

            for(int i = 0; i < string.length(); i++){
                for(int j = 1; j <= string.length()-i; j++){
                    String sub = string.substring(i, i+j);
                    stringSet.add(sub);
                }
            }
        }

        String[] strings = stringSet.toArray(new String[0]);
        return strings;
    }

    public static String[] getCommonPrefixes(String string1, String string2) {

        String[] string1Array = getAllPrefixes(string1);
        String[] string2Array = getAllPrefixes(string2);

        List<String> list = new ArrayList<>();

        for(int i = 0; i < string1Array.length; i++){
            for(int j = 0; j < string2Array.length; j++){
                if(string1Array[i].equals(string2Array[j])){
                        list.add(string1Array[i]);
                }
            }
        }

        return list.toArray(new String[0]);
    }

    public static String getLargestCommonPrefix(String string1, String string2) {

        String[] commonPrefixes = getCommonPrefixes(string1,string2);

        int index = 0;
        int stringLength = commonPrefixes[0].length();


        for(int i = 1; i <= commonPrefixes.length-1; i++){
            if(commonPrefixes[i].length() > stringLength){
                index = i;
                stringLength = commonPrefixes[i].length();
            }
        }

        return commonPrefixes[index];
    }
}
